/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Written by: Joshua Horacsek
 *  Thu Jan  5 22:21:59 2006
 */
 
#include "halo2.h"

void ExtractModel(int tag, int lod, MAP_STRUCT Map, FILE *out){

}

void InjectModel(int tag, int lod, MAP_STRUCT Map, FILE *in){
	
}

void ShiftModels(MAP_STRUCT Map, int offset){
	int i,j,k;
	Reflexive ModeInfo[1],ModeRAW[1];
	uint32 raw;
	for(i=0;i<Map.MetaCount;i++){
		if(strncmp(Map.ItemIndex[i].tagclass,"edom",4)==0){
			fseek(Map.Stream,Map.ItemIndex[i].offset-Map.SecondaryMagic+36,0);
			fread(ModeInfo,1,sizeof(Reflexive),Map.Stream);
			for(j=0;j<ModeInfo[0].ChunkCount;j++){
				fseek(Map.Stream,
				(ModeInfo[0].Offset-Map.SecondaryMagic)+(j*92)+72,0);
				fread(ModeRAW,1,sizeof(Reflexive),Map.Stream);
				for(k=0;k<ModeRAW[0].ChunkCount;k++){
					fseek(Map.Stream,
					(ModeRAW[0].Offset+(k*16)+12)-Map.SecondaryMagic,0);
					
					fread(&raw,1,4,Map.Stream);
					raw += (raw>>28 != 0)? 0 : offset;
					
					fseek(Map.Stream,
					(ModeRAW[0].Offset+(k*16)+12)-Map.SecondaryMagic,0);
					
					fwrite(&raw,1,4,Map.Stream);
				}
			}
		}
	}
}
