/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Written by: Joshua Horacsek
 *  Sun Jan 29 19:11:39 2006
 *
 */
 
#include "halo2.h"

void ShiftAnimations(MAP_STRUCT Map, int offset){
	int i,j;
	uint32 raw;
	for(i=0;i<Map.MetaCount;i++){
		if(TagIsThisClass(i,"damj",Map)){
			for(j=0;j<GetReflexiveChunkCountTag(Map,i,172);j++){
				
				fseek(Map.Stream,
				(GetReflexiveAddressTag(Map,i,172)+(j*24)),0);
	
				fread(&raw,1,4,Map.Stream);
				raw += (raw>>28 != 0)? 0 : offset;
				
				fseek(Map.Stream,
				(GetReflexiveAddressTag(Map,i,172)+(j*24)),0);
				fwrite(&raw,1,4,Map.Stream);
			}
		}
	}
}
