/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Written by: Joshua Horacsek
 *  Sun Jan  8 12:09:22 2006
 *
 */
 
#include "halo2.h"

void ShiftBitmaps(MAP_STRUCT Map, int bytes){
	int i,j,k;
	uint32 offset[6];
	for(i=0;i<Map.MetaCount;i++){
		if(TagIsThisClass(i,"mtib",Map)){
			for(j=0;j<GetReflexiveChunkCountTag(Map,i,68);j++){
				fseek(Map.Stream,
				//Ha, I knew there was a reason I wrote GetReflexiveAddressTag()
				//So I didn't have to use Reflexive BlahBlahBlah[1], too bad
				//I didn't use it... Oh well, I corrected it now
				GetReflexiveAddressTag(Map,i,68)+(116*j)+28,0);
				fread(offset,4,6,Map.Stream);
				
				for(k=0;k<5;k++){
					if(offset[k]>>28==0){
						offset[k]+=bytes;
					}
				}
				
				fseek(Map.Stream,
				GetReflexiveAddressTag(Map,i,68)+(116*j)+28,0);
				fwrite(offset,4,6,Map.Stream);
			}
		}
	}
}
