/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Written by: Joshua Horacsek
 *  Sat Jan  7 17:50:21 2006
 *
 */
#include "halo2.h"

int SwapDependency(char *tag, char *class, int tagtofix, uint32 offset, MAP_STRUCT Map){
	uint32 ID,tagn;
	char *Class;
	if((tagn=FindTag(tag,class,Map))==(-1))
		return -1;
	Class=ClassEdianSwap(class);
	ID=GetTagID(tagn,Map);
	fseek(Map.Stream,GetTagOffset(tagn,Map),0);
	fwrite(Class,1,4,Map.Stream);
	fwrite(&ID,1,4,Map.Stream);
	HaloFree(Class);
	return 0;
}

int SwapDependencyTag(int tag, int tagtofix, uint32 offset, MAP_STRUCT Map){
	uint32 ID;
	ID=GetTagID(tag,Map);
	fseek(Map.Stream,GetTagOffset(tag,Map),0);
	fwrite(GetTagClass(tag,Map),1,4,Map.Stream);
	fwrite(&ID,1,4,Map.Stream);
	return 0;
}
