/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include "halo2.h"

char *ExtractRawMeta(int tag, MAP_STRUCT Map){
	char *ret;
	ret=malloc(GetTagSize(tag, Map));
	fseek(Map.Stream,GetTagOffset(tag,Map),0);
	fread(ret,1,GetTagSize(tag,Map),Map.Stream);
	return ret;
}

void InjectRawMeta(char *buff,int tag, MAP_STRUCT Map){
	fseek(Map.Stream,GetTagOffset(tag,Map),0);
	fwrite(buff,1,GetTagSize(tag,Map),Map.Stream);
}
