/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Written by: Joshua Horacsek
 *  Sun Feb  5 15:17:50 2006
 */
 
#include "halo2.h"
void ShiftWeatherRaw(MAP_STRUCT Map,int tag, int offset){
	uint32 WeatRawAddy,WeatRawCount, Raw, i;
	WeatRawAddy		=	GetReflexiveAddressTag(Map,tag,0);
	WeatRawCount	=	GetReflexiveChunkCountTag(Map,tag,0);
	for(i=0;i<WeatRawCount;i++){
		fseek(Map.Stream,WeatRawAddy+(i*132)+48,0);
		fread(&Raw,1,sizeof(uint32),Map.Stream);
		Raw	+= (isNotExtern(Raw)==0)?offset:0;
		fseek(Map.Stream,WeatRawAddy+(i*132)+48,0);
		fwrite(&Raw,1,sizeof(uint32),Map.Stream);
	}
}
